routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

Route::get('/', function () {
    return redirect('login');
});

Route::group(['middleware' => 'auth', 'namespace' => 'Admin'], function () {
    Route::get('/dashboard', 'DashboardController@index')->name('dashboard');
    Route::get('/profile/me', 'UserController@profile')->name('users.profile');
    Route::get('/request-absent/{request_absent}/approve', 'RequestAbsentController@approve')->name('request-absent.approve');
    Route::post('/request-absent/approve-or-reject', 'RequestAbsentController@approveOrRejectAll')->name('request-absent.approve-or-reject');
    Route::get('/overtimes/{overtime}/approve', 'OvertimeController@approve')->name('overtimes.approve');
    Route::post('/overtime/approve-or-reject', 'OvertimeController@approveOrRejectAll')->name('overtime.approve-or-reject');
    Route::resource('/users', 'UserController');
    Route::resource('/request-absent', 'RequestAbsentController');
    Route::resource('/overtimes', 'OvertimeController');
    Route::resource('/config', 'ConfigController')->middleware('admin');
    Route::resource('/notification', 'NotificationController')->middleware('admin');
    Route::resource('/roles', 'RoleController')->middleware('admin');
    Route::resource('/work-titles', 'WorkTitleController')->middleware('admin');
    Route::get('/timesheets', 'DashboardController@index');
    Route::get('/logout', 'AuthController@logout');
    Route::get('/password/change', 'AuthController@changePasswordEdit')->name('change-password.edit');
    Route::put('/password/change', 'AuthController@changePasswordUpdate')->name('change-password.update');
    Route::get('timesheet/getData', '\App\Http\Controllers\Admin\TimeSheetController@getData')->name('timesheet.getData');
    Route::resource('national-day', '\App\Http\Controllers\Admin\NationalDayController')->middleware('admin');
    Route::resource('timesheet', '\App\Http\Controllers\Admin\TimeSheetController')->except(['show']);
    Route::resource('comments', '\App\Http\Controllers\Admin\CommentController');
    Route::put('timesheet/update-paid-leave/{id}', '\App\Http\Controllers\Admin\TimeSheetController@updatePaidLeave')
            ->name('timesheet.updatePaidLeave');
    Route::post('timesheet/upload-timesheet', '\App\Http\Controllers\Admin\TimeSheetController@uploadTimesheet')
            ->name('timesheet.uploadTimesheet')
            ->middleware('can:timesheet.uploadTimesheet');
    Route::get('timesheet/export-timesheet', '\App\Http\Controllers\Admin\TimeSheetController@ExportTimesheet')
            ->name('timesheet.exportTimesheet');
    Route::get('timesheet/create', '\App\Http\Controllers\Admin\TimeSheetController@create')
        ->name('timesheet.create')->middleware('can:timesheet.create');
    Route::get('timesheet/edit/{timesheet}', '\App\Http\Controllers\Admin\TimeSheetController@edit')
        ->name('timesheet.edit')->middleware('can:timesheet.update');
    Route::delete('timesheet/destroy/{timesheet}', '\App\Http\Controllers\Admin\TimeSheetController@destroy')
        ->name('timesheet.destroy')->middleware('can:timesheet.delete');
    Route::resource('/position', 'PositionController')->middleware('admin');
    Route::post('timesheet/update-all-month', '\App\Http\Controllers\Admin\TimeSheetController@updateMonthAll')
            ->name('timesheet.updateMonthAll')->middleware('admin');
    Route::post('users/upload-users', '\App\Http\Controllers\Admin\UserController@uploadUsers')
            ->name('users.uploadUsers')
            ->middleware('admin');
    Route::get('request-absents/export', '\App\Http\Controllers\Admin\RequestAbsentController@exportRequestAbsent')
            ->name('request-absent.exportRequestAbsent');
    Route::get('overtime/export', '\App\Http\Controllers\Admin\OvertimeController@exportOvertime')
            ->name('overtime.exportOvertime');
});

app/Models/Overtime.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Overtime extends Model
{
    protected $table = 'overtime';

    const STATUS_PENDING = 1;
    const STATUS_APPROVE = 2;
    const STATUS_REJECT = 3;

    protected $fillable = [
        'project',
        'from_time',
        'to_time',
        'reason',
        'status',
        'reason2',
        'created_by',
    ];

    public function overtimeUsers()
    {
        return $this->hasMany(OvertimeUser::class, 'overtime_id', 'id');
    }

    public function scopeMyRequest($query, $userId, $id = '')
    {
       $query->select('overtime.*');
       $query->join('overtime_user', 'overtime.id', '=', 'overtime_user.overtime_id');
        if (!empty($id))
            $query->where('overtime.id', $id);

       $query->where(function ($query) use ($userId) {
           $query->orWhere('overtime.created_by', $userId);
           $query->orWhere('overtime_user.user_id', $userId);
       });
        return $query->groupBy('overtime.id');
    }
}

app/Http/Controllers/API/OvertimeController.php
<?php

namespace App\Http\Controllers\API;

use App\Http\Requests\UpdateOvertimeRequest;
use App\Models\Overtime;
use App\Models\OvertimeUser;
use App\Rules\ExistArrayUser;
use App\Rules\ExistOvertime;
use App\Rules\OvertimeRequest;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;

class OvertimeController extends BaseController
{
    // public function __construct()
    // {
    //     //$this->authorizeResource(Overtime::class);
    // }
    public function index()
    {
        $overtimes = Overtime::myRequest($this->userId)
        ->orderBy('overtime.from_time', 'desc')
        ->orderBy('overtime.created_at', 'desc')
        ->get();
        //->paginate(10);
        return send_success($overtimes);
    }

    public function show($id)
    {
        $overtime = Overtime::myRequest($this->userId, $id)->first();
        if (!$overtime) {
            return send_error('E0401');
        }
        return send_success($overtime);
    }

    public function store(Request $request)
    {
        $validator = $this->validation($request);
        if ($validator->fails()) {
            return $this->sendError('E0003', $validator->errors());
        }
        $overtimeData = $validator->validate();
        $overtimeData['created_by'] = $this->userId;
        DB::beginTransaction();
        try {
            $overtime = Overtime::create($overtimeData);
            if (key_exists('members', $overtimeData)) {
                $overtimeUserData = [];
                foreach ($overtimeData['members'] as $m) {
                    $overtimeUserData[] = ['overtime_id' => $overtime->id, 'user_id' => $m];
                }
                OvertimeUser::insert($overtimeUserData);
            }
            DB::commit();
            return send_success($overtime);
        } catch (\Exception $e) {
            DB::rollBack();
            return send_error('E0005', 'Store request overtime api: ' . $e->getMessage());
        }
    }

    public function update(Request $request,  Overtime $overtime)
    {
        if (!($overtime->created_by == $this->userId && $overtime->status == config('common.overtime.waiting') ||
            $this->userCan('admin', $this->user))) {
            return send_error('E0403');
        }
        $validator = $this->validation($request, $overtime->id);
        if ($validator->fails()) {
            return $this->sendError('E0003', $validator->errors());
        }
        $data = $validator->validate();
        try {
            $overtime->update($data);
            if (key_exists('members', $data)) {
                $overtimeUserData = [];
                foreach ($data['members'] as $m) {
                    $overtimeUserData[] = ['overtime_id' => $overtime->id, 'user_id' => $m];
                }
                $overtime->overtimeUsers()->delete();
                OvertimeUser::insert($overtimeUserData);
            }
            return send_success($overtime);
        } catch (\Exception $e) {
            return send_error('E0005', 'Update request overtime api: ' . $e->getMessage());
        }
    }

    public function destroy(Overtime $overtime)
    {
        if (!($overtime->created_by == $this->userId && $overtime->status == config('common.overtime.waiting') ||
            $this->userCan('admin', $this->user))) {
            return send_error('E0403');
        }
        try {
            $overtime->overtimeUsers()->delete();
            $overtime->delete();
            return send_success();
        } catch (\Exception $e) {
            logger()->error('Delete overtime: ' . $e->getMessage());
            return send_error('E0301');
        }
    }

    public function validation($request, $overtimeId = false)
    {
        // Check validator for param
        $validator = Validator::make($request->all(), [
            'from_time' => ['bail', 'required', 'date',
                new ExistOvertime(\Request::instance()->members, \Request::instance()->to_time, $overtimeId)],
            //'to_time' => 'required|date',
            //'to_time' => 'required|date|after_or_equal:from_time',
            'to_time' => ['required','date', 'after_or_equal:from_time', new OvertimeRequest(\Request::instance()->from_time, \Request::instance()->to_time)],
            'project' => 'required|string',
            'reason' => 'required|string',
            //'members' => 'nullable|array',
            'members' => ['bail', 'required', 'array',
                new ExistArrayUser(\Request::instance()->members)],
        ]);
        return $validator;
    }
}

resources/views/admin/overtime/create.blade.php
@extends('layouts.app')

@section('content')
<div class="container-fluid pb-3">
    @include('layouts.alert')
    <form class="card p-3 rounded-lg" method="POST" action="{{ route('overtimes.store') }}">
        @csrf
        <div class="form-group row">
            <label for="inputFromTime" class="col-sm-2 col-form-label">{{ __('layouts.from_time') }} <code>*</code></label>
            <div class="col-sm-10 input-group">
                <div class="input-group-prepend">
                    <span class="input-group-text">
                        <i class="far fa-calendar-alt"></i>
                    </span>
                </div>
                <input type="text" class="form-control date-time @error('from_time') is-invalid @enderror" id="inputFromTime"
                       placeholder="yyyy/mm/dd --:--" name="from_time" value="{{ old('from_time') }}" autocomplete="off">
                @error('from_time')
                <div class="invalid-feedback">{{ $message }}</div>
                @enderror
            </div>
        </div>
        <div class="form-group row">
            <label for="inputToTime" class="col-sm-2 col-form-label">{{ __('layouts.to_time') }} <code>*</code></label>
            <div class="col-sm-10 input-group">
                <div class="input-group-prepend">
                    <span class="input-group-text">
                        <i class="far fa-calendar-alt"></i>
                    </span>
                </div>
                <input type="text" class="form-control date-time @error('to_time') is-invalid @enderror" id="inputToTime"
                       placeholder="yyyy/mm/dd --:--" name="to_time" value="{{ old('to_time') }}" autocomplete="off">
                @error('to_time')
                <div class="invalid-feedback">{{ $message }}</div>
                @enderror
            </div>
        </div>
        <div class="form-group row">
            <label for="inputProject" class="col-sm-2 col-form-label">{{ __('layouts.project') }} <code>*</code></label>
            <div class="col-sm-10">
                <input type="text" class="form-control @error('project') is-invalid @enderror" id="inputProject" name="project" value="{{ old('project') }}">
                @error('project')
                <div class="invalid-feedback">{{ $message }}</div>
                @enderror
            </div>
        </div>
        <div class="form-group row">
            <label for="inputReason" class="col-sm-2 col-form-label">{{ __('layouts.reason') }} <code>*</code></label>
            <div class="col-sm-10">
                <textarea class="form-control @error('reason') is-invalid @enderror" id="inputReason" rows="3" name="reason">{{ old('reason') }}</textarea>
                @error('reason')
                <div class="invalid-feedback">{{ $message }}</div>
                @enderror
            </div>
        </div>
        <div class="form-group row">
            <label for="inputMembers" class="col-sm-2 col-form-label">{{ __('layouts.members') }}<code>*</code></label>
            <div class="col-sm-10">
                <div class="table-responsive border rounded @error('members') is-invalid @enderror">
                    <table class="table table-borderless table-striped m-0 table-striped-reverse">
                        <tbody>
                            @foreach ($members as $m)
                            <tr>
                                <td>{{ $loop->iteration }}</td>
                                <td>{{ $m->staff_id }}</td>
                                <td class="text-left">{{ get_fullname($m) }}</td>
                                <td>
                                    <div class="custom-control custom-checkbox">
                                        <input type="checkbox" class="custom-control-input @error('members') is-invalid @enderror" id="customCheck{{ $m->id }}"
                                               name="members[]" value="{{ $m->id }}" @if(old('members') && in_array($m->id, old('members'))) checked @endif">
                                        <label class="custom-control-label" for="customCheck{{ $m->id }}"></label>
                                    </div>
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
                @error('members')
                <div class="invalid-feedback">{{ $message }}</div>
                @enderror
            </div>
        </div>
        <div class="d-flex justify-content-end">
            <input class="btn btn-primary btn-width-default" type="submit" value="{{ __('layouts.create') }}">
            <a class="btn btn-dark ml-2 btn-width-default" href="{{ Session::has('backUrl') ? Session::get('backUrl') : route('overtimes.index') }}">{{ __('layouts.close') }}</a>
        </div>
    </form>
</div>
@endsection

resources/views/admin/overtime/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="container-fluid pb-3">
    @include('layouts.alert')
    <form class="card p-3 rounded-lg" method="POST" action="{{ route('overtimes.update', $overtime->id) }}">
        @csrf <input name="_method" value="PUT" hidden>
        <div class="form-group row">
            <label for="inputFromTime" class="col-sm-2 col-form-label">{{ __('layouts.from_time') }} <code>*</code></label>
            <div class="col-sm-10 input-group">
                <div class="input-group-prepend">
                    <span class="input-group-text">
                        <i class="far fa-calendar-alt"></i>
                    </span>
                </div>
                <input type="text" class="form-control date-time @error('from_time') is-invalid @enderror" id="inputFromTime"
                       placeholder="yyyy/mm/dd --:--" name="from_time" autocomplete="off"
                       value="{{ get_datetime(old('from_time', $overtime->from_time), 'Y/m/d H:i') }}" >
                @error('from_time')
                <div class="invalid-feedback">{{ $message }}</div>
                @enderror
            </div>
        </div>
        <div class="form-group row">
            <label for="inputToTime" class="col-sm-2 col-form-label">{{ __('layouts.to_time') }} <code>*</code></label>
            <div class="col-sm-10 input-group">
                <div class="input-group-prepend">
                    <span class="input-group-text">
                        <i class="far fa-calendar-alt"></i>
                    </span>
                </div>
                <input type="text" class="form-control date-time @error('to_time') is-invalid @enderror" id="inputToTime"
                       placeholder="yyyy/mm/dd --:--" name="to_time" autocomplete="off"
                       value="{{ get_datetime(old('to_time', $overtime->to_time), 'Y/m/d H:i') }}">
                @error('to_time')
                <div class="invalid-feedback">{{ $message }}</div>
                @enderror
            </div>
        </div>
        <div class="form-group row">
            <label for="inputProject" class="col-sm-2 col-form-label">{{ __('layouts.project') }} <code>*</code></label>
            <div class="col-sm-10">
                <input type="text" class="form-control @error('project') is-invalid @enderror" id="inputProject"
                       name="project" value="{{ old('project', $overtime->project) }}" >
                @error('project')
                <div class="invalid-feedback">{{ $message }}</div>
                @enderror
            </div>
        </div>
        <div class="form-group row">
            <label for="inputReason" class="col-sm-2 col-form-label">{{ __('layouts.reason') }} <code>*</code></label>
            <div class="col-sm-10">
                <textarea class="form-control @error('reason') is-invalid @enderror" id="inputReason" rows="3"
                          name="reason" >{{ old('reason', $overtime->reason) }}</textarea>
                @error('reason')
                <div class="invalid-feedback">{{ $message }}</div>
                @enderror
            </div>
        </div>
        <div class="form-group row">
            <label for="inputMembers" class="col-sm-2 col-form-label">{{ __('layouts.members') }} <code>*</code></label>
            <div class="col-sm-10">
                <div class="table-responsive border rounded @error('members') is-invalid @enderror">
                    <table class="table table-borderless table-striped m-0 table-striped-reverse">
                        <tbody>
                            @foreach ($members as $m)
                            <tr>
                                <td>{{ $loop->iteration }}</td>
                                <td>{{ $m->staff_id }}</td>
                                <td class="text-left">{{ get_fullname($m) }}</td>
                                <td>
                                    <div class="custom-control custom-checkbox">
                                        <input type="checkbox" class="custom-control-input @error('members') is-invalid @enderror" id="customCheck{{ $m->id }}"
                                               name="members[]" value="{{ $m->id }}"
                                               @if(in_array($m->id, !empty(old()) ? old('members', []) : $memberIds)) checked @endisset>
                                        <label class="custom-control-label" for="customCheck{{ $m->id }}"></label>
                                    </div>
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
                @error('members')
                <div class="invalid-feedback">{{ $message }}</div>
                @enderror
            </div>
        </div>
        <div class="d-flex justify-content-end">
            <input class="btn btn-primary btn-width-default" type="submit" value="{{ __('layouts.save') }}">
            <a class="btn btn-dark ml-2 btn-width-default" href="{{ Session::has('backUrl') ? Session::get('backUrl') : route('overtimes.index') }}">{{ __('layouts.close') }}</a>
        </div>
    </form>
</div>
@endsection

resources/views/admin/overtime/index.blade.php
@extends('layouts.app')

@section('content')

<div class="container-fluid pb-3">
    @include('layouts.alert')
    <div class="card p-3 rounded-lg">
        <form class="overtime_search" method="GET" action="{{ route('overtimes.index') }}">
            <div class="row">
                <label for="name" class="col-form-label ml-3">{{ __('layouts.date') }}</label>
                <div class="col-xl-3 col-sm-6 mb-2">
                    <input type="text" name="date" class="form-control" id="search_date_overtime" autocomplete="off"
                            value="{{ isset($date) ? \Carbon\Carbon::make($date)->format('Y/m') : null }}">
                    <input type="text" value="true" name="isSearch" hidden>
                </div>
                @roles('admin')
                    <label for="name" class="col-form-label mb-2 ml-3">{{ __('layouts.staff_register') }}</label>
                    <div class="col-xl-3 form-group mb-2">
                        <select name="user_id" id="user_id" class="form-control select2 select2-hidden-accessible">
                            <option value="" >{{ __('layouts.all_user') }}</option>
                            @foreach($users as $user)
                                <option value="{{ $user->id }}" {{ $request->user_id == $user->id ? 'selected="selected"' : '' }}>{{ $user->getFullName() }}</option>
                            @endforeach
                        </select>
                    </div>
                    <button class="btn btn-dark ml-3 mb-2 btn-width-default" type="submit">{{ __('layouts.search') }}</button>
                @endroles
                <button style="margin-right: 0.5rem" id="excel_export_overtime" type="button" class="btn btn-primary ml-2 mb-2">{{ __('layouts.export_overtime') }}</button>
            </div>
        </form>
        <div class="row justify-content-end mr-1">
            <div>
                <a class="btn btn-primary text-nowrap btn-width-default" href="{{ route('overtimes.create') }}">{{ __('layouts.add') }}</a>
            </div>
            @if (count($overtimes) > 0)
                <div class="content-approve">
                    @roles('admin')
                        <button value="1" data-route="{{ route('overtime.approve-or-reject') }}" class="mb-2 ml-2 btn btn-success approve_overtime_all" name="status">{{ __('layouts.approve') }}</button>
                        <button style="margin-left: 0.3rem" value="0" data-route="{{ route('overtime.approve-or-reject') }}" class="mb-2 btn btn-danger reject_overtime_all" name="status">{{ __('layouts.reject') }}</button>
                    @endroles
                </div>
            @endif
        </div>
        <div class="table-responsive">
            <table class="table table-striped my-3 table-borderless table-striped-reverse">
                <thead class="thead-dark">
                    <tr>
                        @roles('admin')
                            <th><input type="checkbox" class="check-all" id="overtimes-check"></th>
                        @endroles
                        <th>#</th>
                        <th>{{ __('layouts.registration_applicant') }}</th>
                        <th>{{ __('layouts.ot_members') }}</th>
                        <th>{{ __('layouts.project') }}</th>
                        <th>{{ __('layouts.from_time') }}</th>
                        <th>{{ __('layouts.to_time') }}</th>
                        <th>{{ __('layouts.status') }}</th>
                        <th></th>
                    </tr>
                </thead>
                <tbody>
                    @if (count($overtimes) == 0)
                    <tr>
                        <td class="text-danger no-data" colspan="7">{{ __('messages.no_data') }}</td>
                    </tr>
                    @endif
                    @foreach ($overtimes as $o)
                    <tr>
                        @roles('admin')
                            <td><input type="checkbox" class="overtime-check" data-id="{{$o->id}}"></td>
                        @endroles
                        <td>{{ ($overtimes->currentPage() - 1) * $overtimes->perPage() + $loop->iteration }}</td>
                        <td>{{ $o->staff_id }} {{ get_fullname($o) }}</td>
                        <td class="text-left">
                            <ul>
                                @foreach ($o->overtimeUsers as $u)
                                <li class="text-nowrap">{{ $u->staff_id }} {{ get_fullname($u) }}</li>
                                @endforeach
                            </ul>
                        </td>
                        <td>{{ $o->project }}</td>
                        <td>{{ $o->from_time }}</td>
                        <td>{{ $o->to_time }}</td>
                                                
                        <td>
                            <i class="{{ config('common.status_map.'.$o->status.'.icon') }}" data-toggle="tooltip"
                                title="{{ config('common.status_map.'.$o->status.'.text') }}"></i>
                        </td>
                        
                        <td>
                            <div class="d-flex justify-content-right">
                                @can('approve', $o)
                                    <a class="btn btn-success py-0 px-1 mr-1" href="{{ route('overtimes.approve', $o->id) }}" data-toggle="tooltip" title="{{ __('layouts.approve') }}"><i class="fas fa-check-circle"></i></a>
                                @endcan
                                @can('update', $o)
                                    @if($o->status == config('common.overtime.waiting'))
                                        <a class="btn btn-primary py-0 px-1 mr-1" href="{{ route('overtimes.edit', $o->id) }}" data-toggle="tooltip" title="{{ __('layouts.edit') }}"><i class="fas fa-pen"></i></a>
                                    @endif    
                                @endcan
                                @can('delete', $o)
                                    <form class="inline-block" method="POST" action="{{ route('overtimes.destroy', $o->id) }}">
                                        @csrf
                                        @method('DELETE')
                                        <button class="btn btn-danger py-0 px-1 delete" data-toggle="tooltip" title="{{ __('layouts.delete') }}">
                                            <i class="fas fa-trash-alt"></i>
                                        </button>
                                    </form>
                                @endcan
                            </div>
                        </td>
                    </tr>
                    @endforeach
                </tbody>
            </table>
        </div>
        @include('layouts.paginate', ['paginate' => $overtimes])
    </div>
</div>
@endsection
@section('script')
    <script src="{{ asset('js/bootstrap-datepicker.min.js') }}"></script>
    <script src="{{ asset('js/bootstrap-datepicker.vi.min.js') }}" charset="UTF-8"></script>
    <script type="text/javascript">
        $('#excel_export_overtime').click(function () {
            let userId = $('#user_id').val();
            let date = $('#search_date_overtime').val();
            location = `{{ route("overtime.exportOvertime") }}?user_id=${userId}&date=${date}`;
        })

        $('#search_date_overtime').datepicker({
            format: "yyyy/mm",
            startView: "months",
            minViewMode: "months",
            language: "vi"
        })

        $('#search_date_overtime').on('changeDate', function() {
            let date = $('#search_date_overtime').val();
            location = `{{ route("overtimes.index") }}?date=${date}&isSearch=true`;
        });
    </script>
@endsection